KUBERNETES(1)

NAME

kubectl delete - Delete resources by filenames, stdin, resources and names, or by resources and label selector

SYNOPSIS

kubectl delete [OPTIONS]

DESCRIPTION

Delete resources by filenames, stdin, resources and names, or by resources and label selector.

JSON and YAML formats are accepted. Only one type of the arguments may be specified: filenames, resources and names, or resources and label selector.

Some resources, such as pods, support graceful deletion. These resources define a default period before they are forcibly terminated (the grace period) but you may override that value with the --grace-period flag, or pass --now to set a grace-period of 1. Because these resources often represent entities in the cluster, deletion may not be acknowledged immediately. If the node hosting a pod is down or cannot reach the API server, termination may take significantly longer than the grace period. To force delete a resource, you must pass a grace period of 0 and specify the --force flag.

IMPORTANT: Force deleting pods does not wait for confirmation that the pod's processes have been terminated, which can leave those processes running until the node detects the deletion and completes graceful deletion. If your processes use shared storage or talk to a remote API and depend on the name of the pod to identify themselves, force deleting those pods may result in multiple processes running on different machines using the same identification which may lead to data corruption or inconsistency. Only force delete pods when you are sure the pod is terminated, or if your application can tolerate multiple copies of the same pod running at once. Also, if you force delete pods the scheduler may place new pods on those nodes before the node has released those resources and causing those pods to be evicted immediately.

Note that the delete command does NOT do resource version checks, so if someone submits an update to a resource right when you submit a delete, their update will be lost along with the rest of the resource.

OPTIONS

--all=false
    Delete all resources, including uninitialized ones, in the namespace of the specified resource types.

-A, --all-namespaces=false
    If present, list the requested object(s) across all namespaces. Namespace in current context is ignored even if specified with --namespace.

--cascade=true
    If true, cascade the deletion of the resources managed by this resource (e.g. Pods created by a ReplicationController). Default true.

--field-selector=""
    Selector (field query) to filter on, supports '=', '==', and '!='.(e.g. --field-selector key1=value1,key2=value2). The server only supports a limited number of field queries per type.

-f, --filename=[]
    containing the resource to delete.

--force=false
    Only used when grace-period=0. If true, immediately remove resources from API and bypass graceful deletion. Note that immediate deletion of some resources may result in inconsistency or data loss and requires confirmation.

--grace-period=-1
    Period of time in seconds given to the resource to terminate gracefully. Ignored if negative. Set to 1 for immediate shutdown. Can only be set to 0 when --force is true (force deletion).

--ignore-not-found=false
    Treat "resource not found" as a successful delete. Defaults to "true" when --all is specified.

--include-uninitialized=false
    If true, the kubectl command applies to uninitialized objects. If explicitly set to false, this flag overrides other flags that make the kubectl commands apply to uninitialized objects, e.g., "--all". Objects with empty metadata.initializers are regarded as initialized.

-k, --kustomize=""
    Process a kustomization directory. This flag can't be used together with -f or -R.

--now=false
    If true, resources are signaled for immediate shutdown (same as --grace-period=1).

-o, --output=""
    Output mode. Use "-o name" for shorter output (resource/name).

-R, --recursive=false
    Process the directory used in -f, --filename recursively. Useful when you want to manage related manifests organized within the same directory.

-l, --selector=""
    Selector (label query) to filter on, not including uninitialized ones.

--timeout=0s
    The length of time to wait before giving up on a delete, zero means determine a timeout from the size of the object

--wait=true
    If true, wait for resources to be gone before returning. This waits for finalizers.

OPTIONS INHERITED FROM PARENT COMMANDS

--alsologtostderr=false
    log to standard error as well as files

--application-metrics-count-limit=100
    Max number of application metrics to store (per container)

--as=""
    Username to impersonate for the operation

--as-group=[]
    Group to impersonate for the operation, this flag can be repeated to specify multiple groups.

--azure-container-registry-config=""
    Path to the file containing Azure container registry configuration information.

--boot-id-file="/proc/sys/kernel/random/boot_id"
    Comma-separated list of files to check for boot-id. Use the first one that exists.

--cache-dir="/build/.kube/http-cache"
    Default HTTP cache directory

--certificate-authority=""
    Path to a cert file for the certificate authority

--client-certificate=""
    Path to a client certificate file for TLS

--client-key=""
    Path to a client key file for TLS

--cloud-provider-gce-lb-src-cidrs=130.211.0.0/22,209.85.152.0/22,209.85.204.0/22,35.191.0.0/16
    CIDRs opened in GCE firewall for LB traffic proxy health checks

--cluster=""
    The name of the kubeconfig cluster to use

--container-hints="/etc/cadvisor/container_hints.json"
    location of the container hints file

--containerd="unix:///var/run/containerd.sock"
    containerd endpoint

--context=""
    The name of the kubeconfig context to use

--default-not-ready-toleration-seconds=300
    Indicates the tolerationSeconds of the toleration for notReady:NoExecute that is added by default to every pod that does not already have such a toleration.

--default-unreachable-toleration-seconds=300
    Indicates the tolerationSeconds of the toleration for unreachable:NoExecute that is added by default to every pod that does not already have such a toleration.

--docker="unix:///var/run/docker.sock"
    docker endpoint

--docker-env-metadata-whitelist=""
    a comma-separated list of environment variable keys that needs to be collected for docker containers

--docker-only=false
    Only report docker containers in addition to root stats

--docker-root="/var/lib/docker"
    DEPRECATED: docker root is read from docker info (this is a fallback, default: /var/lib/docker)

--docker-tls=false
    use TLS to connect to docker

--docker-tls-ca="ca.pem"
    path to trusted CA

--docker-tls-cert="cert.pem"
    path to client certificate

--docker-tls-key="key.pem"
    path to private key

--enable-load-reader=false
    Whether to enable cpu load reader

--event-storage-age-limit="default=0"
    Max length of time for which to store events (per type). Value is a comma separated list of key values, where the keys are event types (e.g.: creation, oom) or "default" and the value is a duration. Default is applied to all non-specified event types

--event-storage-event-limit="default=0"
    Max number of events to store (per type). Value is a comma separated list of key values, where the keys are event types (e.g.: creation, oom) or "default" and the value is an integer. Default is applied to all non-specified event types

--global-housekeeping-interval=1m0s
    Interval between global housekeepings

--housekeeping-interval=10s
    Interval between container housekeepings

--insecure-skip-tls-verify=false
    If true, the server's certificate will not be checked for validity. This will make your HTTPS connections insecure

--kubeconfig=""
    Path to the kubeconfig file to use for CLI requests.

--log-backtrace-at=:0
    when logging hits line file:N, emit a stack trace

--log-cadvisor-usage=false
    Whether to log the usage of the cAdvisor container

--log-dir=""
    If non-empty, write log files in this directory

--log-file=""
    If non-empty, use this log file

--log-flush-frequency=5s
    Maximum number of seconds between log flushes

--logtostderr=true
    log to standard error instead of files

--machine-id-file="/etc/machine-id,/var/lib/dbus/machine-id"
    Comma-separated list of files to check for machine-id. Use the first one that exists.

--match-server-version=false
    Require server version to match client version

--mesos-agent="127.0.0.1:5051"
    Mesos agent address

--mesos-agent-timeout=10s
    Mesos agent timeout

-n, --namespace=""
    If present, the namespace scope for this CLI request

--password=""
    Password for basic authentication to the API server

--profile="none"
    Name of profile to capture. One of (none|cpu|heap|goroutine|threadcreate|block|mutex)

--profile-output="profile.pprof"
    Name of the file to write the profile to

--request-timeout="0"
    The length of time to wait before giving up on a single server request. Non-zero values should contain a corresponding time unit (e.g. 1s, 2m, 3h). A value of zero means don't timeout requests.

-s, --server=""
    The address and port of the Kubernetes API server

--skip-headers=false
    If true, avoid header prefixes in the log messages

--stderrthreshold=2
    logs at or above this threshold go to stderr

--storage-driver-buffer-duration=1m0s
    Writes in the storage driver will be buffered for this duration, and committed to the non memory backends as a single transaction

--storage-driver-db="cadvisor"
    database name

--storage-driver-host="localhost:8086"
    database host:port

--storage-driver-password="root"
    database password

--storage-driver-secure=false
    use secure connection with database

--storage-driver-table="stats"
    table name

--storage-driver-user="root"
    database username

--token=""
    Bearer token for authentication to the API server

--update-machine-info-interval=5m0s
    Interval between machine info updates.

--user=""
    The name of the kubeconfig user to use

--username=""
    Username for basic authentication to the API server

-v, --v=0
    number for the log level verbosity

--version=false
    Print version information and quit

--vmodule=
    comma-separated list of pattern=N settings for file-filtered logging

EXAMPLE

      # Delete a pod using the type and name specified in pod.json.
      kubectl delete -f ./pod.json

      # Delete resources from a directory containing kustomization.yaml - e.g. dir/kustomization.yaml.
      kubectl delete -k dir

      # Delete a pod based on the type and name in the JSON passed into stdin.
      cat pod.json | kubectl delete -f -

      # Delete pods and services with same names "baz" and "foo"
      kubectl delete pod,service baz foo

      # Delete pods and services with label name=myLabel.
      kubectl delete pods,services -l name=myLabel

      # Delete a pod with minimal delay
      kubectl delete pod foo --now

      # Force delete a pod on a dead node
      kubectl delete pod foo --grace-period=0 --force

      # Delete all pods
      kubectl delete pods --all

SEE ALSO

kubectl(1),

HISTORY

January 2015, Originally compiled by Eric Paris (eparis at redhat dot com) based on the kubernetes source material, but hopefully they have been automatically generated since!